commit 4ca686e8fc9734522fb8deabe0b0252df5e9878c
Author: Martin Toutant <martin.toutant@inrae.fr>
Date:   Wed Aug 3 17:09:21 2022 +0200

    project rename

diff --git a/TestTeoBluetooth/TestTeoBluetooth.Android/MainActivity.cs b/TestTeoBluetooth/TestTeoBluetooth.Android/MainActivity.cs
index 42fbd9c..25e76c3 100644
--- a/TestTeoBluetooth/TestTeoBluetooth.Android/MainActivity.cs
+++ b/TestTeoBluetooth/TestTeoBluetooth.Android/MainActivity.cs
@@ -5,9 +5,9 @@ using Android.Content.PM;
 using Android.Runtime;
 using Android.OS;
 using Xamarin.Forms;
-using TestBLE.Services;
+using TeoTestBluetooth.Services;
 
-namespace TestBLE.Droid
+namespace TeoTestBluetooth.Droid
 {
     [Activity(Label = "TestBLE", Icon = "@mipmap/icon", Theme = "@style/MainTheme", MainLauncher = true, ConfigurationChanges = ConfigChanges.ScreenSize | ConfigChanges.Orientation | ConfigChanges.UiMode | ConfigChanges.ScreenLayout | ConfigChanges.SmallestScreenSize )]
     public class MainActivity : global::Xamarin.Forms.Platform.Android.FormsAppCompatActivity
diff --git a/TestTeoBluetooth/TestTeoBluetooth.Android/Receivers/BluetoothReceiver.cs b/TestTeoBluetooth/TestTeoBluetooth.Android/Receivers/BluetoothReceiver.cs
index 7e694cb..bbc6dca 100644
--- a/TestTeoBluetooth/TestTeoBluetooth.Android/Receivers/BluetoothReceiver.cs
+++ b/TestTeoBluetooth/TestTeoBluetooth.Android/Receivers/BluetoothReceiver.cs
@@ -10,7 +10,7 @@ using System.Collections.Generic;
 using System.Linq;
 using System.Text;
 
-namespace TestBLE.Droid.Receivers
+namespace TeoTestBluetooth.Droid.Receivers
 {
     public class BluetoothReceiver : BroadcastReceiver
     {
diff --git a/TestTeoBluetooth/TestTeoBluetooth.Android/Services/BluetoothService.cs b/TestTeoBluetooth/TestTeoBluetooth.Android/Services/BluetoothService.cs
index 03ae9c5..6eacae9 100644
--- a/TestTeoBluetooth/TestTeoBluetooth.Android/Services/BluetoothService.cs
+++ b/TestTeoBluetooth/TestTeoBluetooth.Android/Services/BluetoothService.cs
@@ -14,26 +14,24 @@ using System.Linq;
 using System.Text;
 using System.Threading;
 using System.Threading.Tasks;
-using TestBLE.Droid.Receivers;
-using TestBLE.Droid.Utils;
-using TestBLE.Models;
-using TestBLE.Services;
+using TeoTestBluetooth.Droid.Receivers;
+using TeoTestBluetooth.Droid.Utils;
+using TeoTestBluetooth.Models;
+using TeoTestBluetooth.Services;
 
-namespace TestBLE.Droid.Services
+namespace TeoTestBluetooth.Droid.Services
 {
     public class BluetoothService : IBluetoothService
     {
 
-        private List<BluetoothDevice> discoveredDevices = new List<BluetoothDevice>();
+        private readonly List<BluetoothDevice> discoveredDevices = new List<BluetoothDevice>();
+        private readonly BluetoothAdapter bluetoothAdapter;
+        private readonly BluetoothReceiver bluetoothReceiver;
         private TaskCompletionSource<bool> scanCompletionSource;
-        private BluetoothManager bluetoothManager;
-        private BluetoothAdapter bluetoothAdapter;
-        private BluetoothReceiver bluetoothReceiver;
 
         private Thread listeningThread;
         private BluetoothSocket socket;
         private readonly string sppUUID = "00001101-0000-1000-8000-00805f9b34fb";
-        private string bufferedData;
 
         public ObservableCollection<BTDevice> FoundDevices = new ObservableCollection<BTDevice>();
         public BluetoothService()
@@ -212,12 +210,6 @@ namespace TestBLE.Droid.Services
             return Task.FromResult(true);
         }
 
-        private byte[] hexValuesToByteArray(string[] hexValues)
-        {
-            byte[] ret = hexValues.Select(value => Convert.ToByte(value, 16)).ToArray();
-            return ret;
-        }
-
         public Task<bool> SendHexValues(byte[] hexValues)
         {
             if (socket.IsConnected == false)
diff --git a/TestTeoBluetooth/TestTeoBluetooth.Android/Utils/TaskExtensions.cs b/TestTeoBluetooth/TestTeoBluetooth.Android/Utils/TaskExtensions.cs
index ee1bb69..3e1d97d 100644
--- a/TestTeoBluetooth/TestTeoBluetooth.Android/Utils/TaskExtensions.cs
+++ b/TestTeoBluetooth/TestTeoBluetooth.Android/Utils/TaskExtensions.cs
@@ -11,7 +11,7 @@ using System.Text;
 using System.Threading;
 using System.Threading.Tasks;
 
-namespace TestBLE.Droid.Utils
+namespace TeoTestBluetooth.Droid.Utils
 {
     public static class TaskExtensions
     {
diff --git a/TestTeoBluetooth/TestTeoBluetooth/App.xaml b/TestTeoBluetooth/TestTeoBluetooth/App.xaml
index f6b9b5a..6e078e2 100644
--- a/TestTeoBluetooth/TestTeoBluetooth/App.xaml
+++ b/TestTeoBluetooth/TestTeoBluetooth/App.xaml
@@ -1,6 +1,6 @@
 ﻿<?xml version="1.0" encoding="utf-8" ?>
 <Application
-    x:Class="TestBLE.App"
+    x:Class="TeoTestBluetooth.App"
     xmlns="http://xamarin.com/schemas/2014/forms"
     xmlns:x="http://schemas.microsoft.com/winfx/2009/xaml">
     <Application.Resources />
diff --git a/TestTeoBluetooth/TestTeoBluetooth/App.xaml.cs b/TestTeoBluetooth/TestTeoBluetooth/App.xaml.cs
index c5d581c..6d157bc 100644
--- a/TestTeoBluetooth/TestTeoBluetooth/App.xaml.cs
+++ b/TestTeoBluetooth/TestTeoBluetooth/App.xaml.cs
@@ -1,9 +1,9 @@
 ﻿using System;
-using TestBLE.Views;
+using TeoTestBluetooth.Views;
 using Xamarin.Forms;
 using Xamarin.Forms.Xaml;
 
-namespace TestBLE
+namespace TeoTestBluetooth
 {
     public partial class App : Application
     {
diff --git a/TestTeoBluetooth/TestTeoBluetooth/MainPage.xaml b/TestTeoBluetooth/TestTeoBluetooth/MainPage.xaml
index 2c9f864..867fb4b 100644
--- a/TestTeoBluetooth/TestTeoBluetooth/MainPage.xaml
+++ b/TestTeoBluetooth/TestTeoBluetooth/MainPage.xaml
@@ -1,7 +1,7 @@
 ﻿<?xml version="1.0" encoding="utf-8" ?>
 <ContentPage xmlns="http://xamarin.com/schemas/2014/forms"
              xmlns:x="http://schemas.microsoft.com/winfx/2009/xaml"
-             x:Class="TestBLE.MainPage">
+             x:Class="TeoTestBluetooth.MainPage">
 
     <StackLayout>
         <Frame BackgroundColor="#2196F3" Padding="24" CornerRadius="0">
diff --git a/TestTeoBluetooth/TestTeoBluetooth/MainPage.xaml.cs b/TestTeoBluetooth/TestTeoBluetooth/MainPage.xaml.cs
index 800cf22..542bcec 100644
--- a/TestTeoBluetooth/TestTeoBluetooth/MainPage.xaml.cs
+++ b/TestTeoBluetooth/TestTeoBluetooth/MainPage.xaml.cs
@@ -6,7 +6,7 @@ using System.Text;
 using System.Threading.Tasks;
 using Xamarin.Forms;
 
-namespace TestBLE
+namespace TeoTestBluetooth
 {
     public partial class MainPage : ContentPage
     {
diff --git a/TestTeoBluetooth/TestTeoBluetooth/Models/BTDevice.cs b/TestTeoBluetooth/TestTeoBluetooth/Models/BTDevice.cs
index 3bc5ef9..2d62669 100644
--- a/TestTeoBluetooth/TestTeoBluetooth/Models/BTDevice.cs
+++ b/TestTeoBluetooth/TestTeoBluetooth/Models/BTDevice.cs
@@ -2,7 +2,7 @@
 using System.Collections.Generic;
 using System.Text;
 
-namespace TestBLE.Models
+namespace TeoTestBluetooth.Models
 {
     public class BTDevice
     {
diff --git a/TestTeoBluetooth/TestTeoBluetooth/Models/ReponsePesee.cs b/TestTeoBluetooth/TestTeoBluetooth/Models/ReponsePesee.cs
index 04d675a..1937014 100644
--- a/TestTeoBluetooth/TestTeoBluetooth/Models/ReponsePesee.cs
+++ b/TestTeoBluetooth/TestTeoBluetooth/Models/ReponsePesee.cs
@@ -3,7 +3,7 @@ using System.Collections.Generic;
 using System.Linq;
 using System.Text;
 
-namespace TestBLE.Models
+namespace TeoTestBluetooth.Models
 {
     public class ReponsePesee
     {
diff --git a/TestTeoBluetooth/TestTeoBluetooth/Models/TeoBluetoothCommands.cs b/TestTeoBluetooth/TestTeoBluetooth/Models/TeoBluetoothCommands.cs
index 8b15598..40551b0 100644
--- a/TestTeoBluetooth/TestTeoBluetooth/Models/TeoBluetoothCommands.cs
+++ b/TestTeoBluetooth/TestTeoBluetooth/Models/TeoBluetoothCommands.cs
@@ -2,7 +2,7 @@
 using System.Collections.Generic;
 using System.Text;
 
-namespace TestBLE.Models
+namespace TeoTestBluetooth.Models
 {
     public static class TeoBluetoothCommand
     {
diff --git a/TestTeoBluetooth/TestTeoBluetooth/Services/IBluetoothService.cs b/TestTeoBluetooth/TestTeoBluetooth/Services/IBluetoothService.cs
index a990be4..9f7b002 100644
--- a/TestTeoBluetooth/TestTeoBluetooth/Services/IBluetoothService.cs
+++ b/TestTeoBluetooth/TestTeoBluetooth/Services/IBluetoothService.cs
@@ -3,9 +3,9 @@ using System.Collections.Generic;
 using System.Collections.ObjectModel;
 using System.Text;
 using System.Threading.Tasks;
-using TestBLE.Models;
+using TeoTestBluetooth.Models;
 
-namespace TestBLE.Services
+namespace TeoTestBluetooth.Services
 {
     public interface IBluetoothService
     {
diff --git a/TestTeoBluetooth/TestTeoBluetooth/ViewModels/AccueilViewModel.cs b/TestTeoBluetooth/TestTeoBluetooth/ViewModels/AccueilViewModel.cs
index d31df3a..2ea8cda 100644
--- a/TestTeoBluetooth/TestTeoBluetooth/ViewModels/AccueilViewModel.cs
+++ b/TestTeoBluetooth/TestTeoBluetooth/ViewModels/AccueilViewModel.cs
@@ -5,12 +5,12 @@ using System.Linq;
 using System.Text;
 using System.Threading.Tasks;
 using System.Windows.Input;
-using TestBLE.Models;
-using TestBLE.Services;
+using TeoTestBluetooth.Models;
+using TeoTestBluetooth.Services;
 using Xamarin.Essentials;
 using Xamarin.Forms;
 
-namespace TestBLE.ViewModels
+namespace TeoTestBluetooth.ViewModels
 {
     public class AccueilViewModel : ViewModelBase
     {
diff --git a/TestTeoBluetooth/TestTeoBluetooth/ViewModels/CommandItemViewModel.cs b/TestTeoBluetooth/TestTeoBluetooth/ViewModels/CommandItemViewModel.cs
index 6167c7a..a8fcad1 100644
--- a/TestTeoBluetooth/TestTeoBluetooth/ViewModels/CommandItemViewModel.cs
+++ b/TestTeoBluetooth/TestTeoBluetooth/ViewModels/CommandItemViewModel.cs
@@ -1,10 +1,10 @@
 ﻿using System.Threading.Tasks;
 using System.Windows.Input;
-using TestBLE.Models;
-using TestBLE.Services;
+using TeoTestBluetooth.Models;
+using TeoTestBluetooth.Services;
 using Xamarin.Forms;
 
-namespace TestBLE.ViewModels
+namespace TeoTestBluetooth.ViewModels
 {
     public class CommandItemViewModel : ViewModelBase
     {   
diff --git a/TestTeoBluetooth/TestTeoBluetooth/ViewModels/DeviceItemViewModel.cs b/TestTeoBluetooth/TestTeoBluetooth/ViewModels/DeviceItemViewModel.cs
index e6685cb..49cb505 100644
--- a/TestTeoBluetooth/TestTeoBluetooth/ViewModels/DeviceItemViewModel.cs
+++ b/TestTeoBluetooth/TestTeoBluetooth/ViewModels/DeviceItemViewModel.cs
@@ -4,12 +4,12 @@ using System.Collections.Generic;
 using System.Text;
 using System.Threading.Tasks;
 using System.Windows.Input;
-using TestBLE.Models;
-using TestBLE.Services;
-using TestBLE.Views;
+using TeoTestBluetooth.Models;
+using TeoTestBluetooth.Services;
+using TeoTestBluetooth.Views;
 using Xamarin.Forms;
 
-namespace TestBLE.ViewModels
+namespace TeoTestBluetooth.ViewModels
 {
     public class DeviceItemViewModel : ViewModelBase
     {
diff --git a/TestTeoBluetooth/TestTeoBluetooth/ViewModels/DeviceViewModel.cs b/TestTeoBluetooth/TestTeoBluetooth/ViewModels/DeviceViewModel.cs
index 79f2e6b..0c8dedb 100644
--- a/TestTeoBluetooth/TestTeoBluetooth/ViewModels/DeviceViewModel.cs
+++ b/TestTeoBluetooth/TestTeoBluetooth/ViewModels/DeviceViewModel.cs
@@ -4,12 +4,12 @@ using System.Collections.ObjectModel;
 using System.Text;
 using System.Threading.Tasks;
 using System.Windows.Input;
-using TestBLE.Models;
-using TestBLE.Services;
+using TeoTestBluetooth.Models;
+using TeoTestBluetooth.Services;
 using Xamarin.Forms;
-using static TestBLE.Models.TeoBluetoothCommand;
+using static TeoTestBluetooth.Models.TeoBluetoothCommand;
 
-namespace TestBLE.ViewModels
+namespace TeoTestBluetooth.ViewModels
 {
     public class DeviceViewModel : ViewModelBase
     {
diff --git a/TestTeoBluetooth/TestTeoBluetooth/ViewModels/ViewModelBase.cs b/TestTeoBluetooth/TestTeoBluetooth/ViewModels/ViewModelBase.cs
index 63618cc..b385a56 100644
--- a/TestTeoBluetooth/TestTeoBluetooth/ViewModels/ViewModelBase.cs
+++ b/TestTeoBluetooth/TestTeoBluetooth/ViewModels/ViewModelBase.cs
@@ -4,7 +4,7 @@ using System.ComponentModel;
 using System.Runtime.CompilerServices;
 using System.Text;
 
-namespace TestBLE.ViewModels
+namespace TeoTestBluetooth.ViewModels
 {
     public class ViewModelBase : INotifyPropertyChanged
     {
diff --git a/TestTeoBluetooth/TestTeoBluetooth/Views/AccueilView.xaml b/TestTeoBluetooth/TestTeoBluetooth/Views/AccueilView.xaml
index 1047265..52d260b 100644
--- a/TestTeoBluetooth/TestTeoBluetooth/Views/AccueilView.xaml
+++ b/TestTeoBluetooth/TestTeoBluetooth/Views/AccueilView.xaml
@@ -1,6 +1,6 @@
 ﻿<?xml version="1.0" encoding="utf-8" ?>
 <ContentPage
-    x:Class="TestBLE.Views.AccueilView"
+    x:Class="TeoTestBluetooth.Views.AccueilView"
     xmlns="http://xamarin.com/schemas/2014/forms"
     xmlns:x="http://schemas.microsoft.com/winfx/2009/xaml"
     xmlns:xe="clr-namespace:XamEffects;assembly=XamEffects"
diff --git a/TestTeoBluetooth/TestTeoBluetooth/Views/AccueilView.xaml.cs b/TestTeoBluetooth/TestTeoBluetooth/Views/AccueilView.xaml.cs
index dff3c50..3507719 100644
--- a/TestTeoBluetooth/TestTeoBluetooth/Views/AccueilView.xaml.cs
+++ b/TestTeoBluetooth/TestTeoBluetooth/Views/AccueilView.xaml.cs
@@ -3,11 +3,11 @@ using System.Collections.Generic;
 using System.Linq;
 using System.Text;
 using System.Threading.Tasks;
-using TestBLE.ViewModels;
+using TeoTestBluetooth.ViewModels;
 using Xamarin.Forms;
 using Xamarin.Forms.Xaml;
 
-namespace TestBLE.Views
+namespace TeoTestBluetooth.Views
 {
     [XamlCompilation(XamlCompilationOptions.Compile)]
     public partial class AccueilView : ContentPage
diff --git a/TestTeoBluetooth/TestTeoBluetooth/Views/DeviceView.xaml b/TestTeoBluetooth/TestTeoBluetooth/Views/DeviceView.xaml
index 145ab32..e44df96 100644
--- a/TestTeoBluetooth/TestTeoBluetooth/Views/DeviceView.xaml
+++ b/TestTeoBluetooth/TestTeoBluetooth/Views/DeviceView.xaml
@@ -1,6 +1,6 @@
 ﻿<?xml version="1.0" encoding="UTF-8" ?>
 <ContentPage
-    x:Class="TestBLE.Views.DeviceView"
+    x:Class="TeoTestBluetooth.Views.DeviceView"
     xmlns="http://xamarin.com/schemas/2014/forms"
     xmlns:x="http://schemas.microsoft.com/winfx/2009/xaml"
     xmlns:xe="clr-namespace:XamEffects;assembly=XamEffects"
diff --git a/TestTeoBluetooth/TestTeoBluetooth/Views/DeviceView.xaml.cs b/TestTeoBluetooth/TestTeoBluetooth/Views/DeviceView.xaml.cs
index 7bf8e95..75a5921 100644
--- a/TestTeoBluetooth/TestTeoBluetooth/Views/DeviceView.xaml.cs
+++ b/TestTeoBluetooth/TestTeoBluetooth/Views/DeviceView.xaml.cs
@@ -3,12 +3,12 @@ using System.Collections.Generic;
 using System.Linq;
 using System.Text;
 using System.Threading.Tasks;
-using TestBLE.Models;
-using TestBLE.ViewModels;
+using TeoTestBluetooth.Models;
+using TeoTestBluetooth.ViewModels;
 using Xamarin.Forms;
 using Xamarin.Forms.Xaml;
 
-namespace TestBLE.Views
+namespace TeoTestBluetooth.Views
 {
     [XamlCompilation(XamlCompilationOptions.Compile)]
     public partial class DeviceView : ContentPage