commit 957b1f34402b8103c32c7126bf774b81ff44286d
Author: lbihannic <lucas.bihannic@inrae.fr>
Date:   Tue Apr 8 13:39:31 2025 +0200

    add end day and end day calibration

diff --git a/GES_PAC/AppShell.xaml.cs b/GES_PAC/AppShell.xaml.cs
index f8ddc69..7ffab01 100644
--- a/GES_PAC/AppShell.xaml.cs
+++ b/GES_PAC/AppShell.xaml.cs
@@ -22,6 +22,7 @@ namespace GES_PAC
             Routing.RegisterRoute(nameof(CreateMeasureView), typeof(CreateMeasureView));
             Routing.RegisterRoute(nameof(CreateBehaviourView), typeof(CreateBehaviourView));
             Routing.RegisterRoute(nameof(EndSetView), typeof(EndSetView));
+            Routing.RegisterRoute(nameof(EndDayView), typeof(EndDayView));
         }
     }
 }
diff --git a/GES_PAC/GES_PAC.csproj b/GES_PAC/GES_PAC.csproj
index f4fce9a..d820698 100644
--- a/GES_PAC/GES_PAC.csproj
+++ b/GES_PAC/GES_PAC.csproj
@@ -114,6 +114,9 @@
 	  <MauiXaml Update="View\CreateSetView.xaml">
 	    <Generator>MSBuild:Compile</Generator>
 	  </MauiXaml>
+	  <MauiXaml Update="View\EndDayView.xaml">
+	    <Generator>MSBuild:Compile</Generator>
+	  </MauiXaml>
 	  <MauiXaml Update="View\EndSetView.xaml">
 	    <Generator>MSBuild:Compile</Generator>
 	  </MauiXaml>
diff --git a/GES_PAC/Model/Calibration.cs b/GES_PAC/Model/Calibration.cs
index 38dd704..94dc626 100644
--- a/GES_PAC/Model/Calibration.cs
+++ b/GES_PAC/Model/Calibration.cs
@@ -1,4 +1,5 @@
 
+
 namespace GES_PAC.Model
 {
     public class Calibration
@@ -34,5 +35,10 @@ namespace GES_PAC.Model
         {
             return Mesures.Select(m => m.Type).Distinct().ToList();
         }
+
+        internal MesureCalibration? getMesureCalibrationByType(TypeCalibration typeCalibration)
+        {
+            return Mesures.FirstOrDefault(mc => mc.Type == typeCalibration);
+        }
     }
 }
diff --git a/GES_PAC/Model/Journee.cs b/GES_PAC/Model/Journee.cs
index 479fcb4..5f94368 100644
--- a/GES_PAC/Model/Journee.cs
+++ b/GES_PAC/Model/Journee.cs
@@ -1,7 +1,3 @@
-
-using System.Diagnostics;
-using System.Linq;
-
 namespace GES_PAC.Model
 {
     public class Journee
@@ -80,6 +76,32 @@ namespace GES_PAC.Model
         {
             return Series.Count > 0;
         }
+        internal int GetSetCount()
+        {
+            return Series.Count;
+        }
+        internal int GetDayAnimalCount()
+        {
+            return Series.Sum(s => s.GetAnimalCount());
+        }
+
+        internal int GetDayMeasureCount()
+        {
+            return Series.Sum(s => s.GetMeasureCount());
+        }
+
+        internal int GetDayBehaviourCount()
+        {
+            return Series.Sum(s => s.GetBehaviourCount());
+        }
+        internal Calibration GetLastCalibration()
+        {
+            return Calibrations.Last();
+        }
+        internal Calibration GetDebutCalibration()
+        {
+            return Calibrations.First(c => c.Phase == PhaseCalibration.Debut);
+        }
         #endregion
     }
 }
diff --git a/GES_PAC/View/CreateCalibrationView.xaml b/GES_PAC/View/CreateCalibrationView.xaml
index 8c5e2f4..61f4ef3 100644
--- a/GES_PAC/View/CreateCalibrationView.xaml
+++ b/GES_PAC/View/CreateCalibrationView.xaml
@@ -40,7 +40,16 @@
                         <!-- CH4 -->
                         <VerticalStackLayout>
                             <Label Text="CH4 (ppm)" FontSize="14" TextColor="Gray" FontAttributes="Bold"/>
-							<controls:DoubleEntry Text="{Binding ConcCH4, Mode=OneWayToSource, TargetNullValue=''}" />
+                            <Grid ColumnDefinitions="*,Auto" ColumnSpacing="5">
+                                <controls:DoubleEntry Text="{Binding ConcCH4, Mode=OneWayToSource, TargetNullValue=''}" />
+                                <Label Grid.Column="1"
+                                   Text="{Binding LastCH4, StringFormat='[{0} ppm]'}"
+                                   FontSize="16"
+                                   TextColor="{Binding LastCH4Color}"
+                                   VerticalOptions="Center"
+                                   HorizontalOptions="End"
+                                   IsVisible="{Binding HasLastMeasure}" />
+                            </Grid>
                             <Label Text="Entrez une valeur"
                                 FontSize="12"
                                 TextColor="Red"
@@ -50,7 +59,16 @@
                         <!-- O2 -->
                         <VerticalStackLayout>
                             <Label Text="O2 (% vol.)" FontSize="14" TextColor="Gray" FontAttributes="Bold"/>
-							<controls:DoubleEntry Text="{Binding ConcO2, Mode=OneWayToSource, TargetNullValue=''}" />
+                            <Grid ColumnDefinitions="*,Auto" ColumnSpacing="5">
+                                <controls:DoubleEntry Text="{Binding ConcO2, Mode=OneWayToSource, TargetNullValue=''}" />
+                                <Label Grid.Column="1"
+                                   Text="{Binding LastO2, StringFormat='[{0} %]'}"
+                                   FontSize="16"
+                                   TextColor="{Binding LastO2Color}"
+                                   VerticalOptions="Center"
+                                   HorizontalOptions="End"
+                                   IsVisible="{Binding HasLastMeasure}" />
+                            </Grid>
                             <Label Text="Entrez une valeur"
                                 FontSize="12"
                                 TextColor="Red"
@@ -60,7 +78,16 @@
                         <!-- CO2 -->
                         <VerticalStackLayout>
                             <Label Text="CO2 (% vol.)" FontSize="14" TextColor="Gray" FontAttributes="Bold"/>
-							<controls:DoubleEntry Text="{Binding ConcCO2, Mode=OneWayToSource, TargetNullValue=''}" />
+                            <Grid ColumnDefinitions="*,Auto" ColumnSpacing="5">
+                                <controls:DoubleEntry Text="{Binding ConcCO2, Mode=OneWayToSource, TargetNullValue=''}" />
+                                <Label Grid.Column="1"
+                                   Text="{Binding LastCO2, StringFormat='[{0} %]'}"
+                                   FontSize="16"
+                                   TextColor="{Binding LastCO2Color}"
+                                   VerticalOptions="Center"
+                                   HorizontalOptions="End"
+                                   IsVisible="{Binding HasLastMeasure}" />
+                            </Grid>
                             <Label Text="Entrez une valeur"
                                 FontSize="12"
                                 TextColor="Red"
diff --git a/GES_PAC/View/EndDayView.xaml b/GES_PAC/View/EndDayView.xaml
new file mode 100644
index 0000000..279f0ab
--- /dev/null
+++ b/GES_PAC/View/EndDayView.xaml
@@ -0,0 +1,78 @@
+<?xml version="1.0" encoding="utf-8" ?>
+<ContentPage xmlns="http://schemas.microsoft.com/dotnet/2021/maui"
+             xmlns:x="http://schemas.microsoft.com/winfx/2009/xaml"
+             xmlns:vm="clr-namespace:GES_PAC.ViewModel"
+             xmlns:tools="clr-namespace:GES_PAC.View.Tools"
+             x:Class="GES_PAC.View.EndDayView"
+             x:DataType="vm:EndDayViewModel">
+
+    <Grid>
+        <StackLayout BackgroundColor="White" Spacing="50">
+
+            <tools:ConnectionIndicatorView />
+            <ScrollView>
+                <StackLayout Spacing="50">
+
+                    <Label Text="Terminer la journée ?"
+                       FontSize="22"
+                       FontAttributes="Bold"
+                       HorizontalOptions="Center"/>
+
+                    <Label
+                        Text="{Binding NumberSet, StringFormat='Nombre de séries : {0}'}"
+                        FontSize="16"
+                        HorizontalOptions="Center" />
+
+                    <Label
+                        Text="{Binding NumberAnimal, StringFormat='Nombre d animaux étudiés : {0}'}"
+                        FontSize="16"
+                        HorizontalOptions="Center" />
+
+                    <Label
+                        Text="{Binding NumberMeasure, StringFormat='Nombre de mesures : {0}'}"
+                        FontSize="16"
+                        HorizontalOptions="Center" />
+
+                    <Label
+                        Text="{Binding NumberBehaviour, StringFormat='Nombre de comportements : {0}'}"
+                        FontSize="16"
+                        HorizontalOptions="Center" />
+
+                </StackLayout>
+            </ScrollView>
+            <StackLayout
+                Margin="10"
+                HorizontalOptions="CenterAndExpand"
+                Orientation="Horizontal"
+                VerticalOptions="FillAndExpand">
+
+                <Button 
+                    Text="Confirmer"
+                    Command="{Binding GoToCalibrationCommand}"
+                    Style="{StaticResource btnNormal}"
+                    VerticalOptions="End"/>
+            </StackLayout>
+        </StackLayout>
+        <Grid Grid.RowSpan="1" IsVisible="{Binding IsBusy}">
+            <Border StrokeThickness="0"
+                Background="Black"
+                Opacity="0.5"
+                Padding="20"
+                WidthRequest="160"
+                HeightRequest="160"
+                HorizontalOptions="Center"
+                VerticalOptions="Center"
+                StrokeShape="RoundRectangle 20">
+
+                <VerticalStackLayout HorizontalOptions="Center" VerticalOptions="Center">
+                    <ActivityIndicator IsRunning="True" Color="White" />
+                    <Label Text="Chargement..."
+                        FontSize="14"
+                        TextColor="white"
+                        HorizontalOptions="Center"/>
+                </VerticalStackLayout>
+            </Border>
+        </Grid>
+
+    </Grid>
+</ContentPage>
diff --git a/GES_PAC/View/EndDayView.xaml.cs b/GES_PAC/View/EndDayView.xaml.cs
new file mode 100644
index 0000000..317ece3
--- /dev/null
+++ b/GES_PAC/View/EndDayView.xaml.cs
@@ -0,0 +1,13 @@
+﻿using GES_PAC.ViewModel;
+
+namespace GES_PAC.View
+{
+    public partial class EndDayView
+    {
+        public EndDayView()
+        {
+            InitializeComponent();
+            BindingContext = new EndDayViewModel();
+        }
+    }
+}
\ No newline at end of file
diff --git a/GES_PAC/View/EndSetView.xaml b/GES_PAC/View/EndSetView.xaml
index 5cee9cc..4fb2da8 100644
--- a/GES_PAC/View/EndSetView.xaml
+++ b/GES_PAC/View/EndSetView.xaml
@@ -43,7 +43,7 @@
 
                 <Button 
                     Text="Confirmer"
-                    Command="{Binding GoToCreateDayCommand}"
+                    Command="{Binding GoToSetListCommand}"
                     Style="{StaticResource btnNormal}"
                     VerticalOptions="End"/>
             </StackLayout>
diff --git a/GES_PAC/View/SetListView.xaml b/GES_PAC/View/SetListView.xaml
index 11b0ae5..20b05bc 100644
--- a/GES_PAC/View/SetListView.xaml
+++ b/GES_PAC/View/SetListView.xaml
@@ -1,70 +1,70 @@
 <?xml version="1.0" encoding="utf-8" ?>
-<ContentPage xmlns="http://schemas.microsoft.com/dotnet/2021/maui"
-             xmlns:x="http://schemas.microsoft.com/winfx/2009/xaml"
-             xmlns:vm="clr-namespace:GES_PAC.ViewModel"
-             xmlns:tools="clr-namespace:GES_PAC.View.Tools"
-             x:Class="GES_PAC.View.SetListView"
-             x:DataType="vm:SetListViewModel">
-
-    <Grid>
-        <StackLayout BackgroundColor="White" Spacing="50">
-
-            <tools:ConnectionIndicatorView />
-            <ScrollView>
-                <StackLayout Spacing="100">
-
-                    <Label Text="{Binding LastSetText}"
-                        FontSize="18"
-                        HorizontalOptions="Center"/>
-
-
-                </StackLayout>
-            </ScrollView>
-            <Grid ColumnDefinitions="*,Auto,*,Auto,*"  
-                  HorizontalOptions="Center"  
-                  VerticalOptions="FillAndExpand">
-
-                <Button  
-                    Grid.Column="1"  
-                    Text="Reprendre la série"  
-                    Command="{Binding GoToLastSetCommand}"  
-                    Style="{StaticResource btnNormal}"  
-                    VerticalOptions="End"  
-                    HorizontalOptions="Start"  
-                    IsVisible="{Binding HasLastSet}" 
-                    Margin="0,0,20,20"/>
-
-                <Button  
-                    Grid.Column="3"  
-                    Text="Créer une série"  
-                    Command="{Binding GoToCreateSetCommand}"  
-                    Style="{StaticResource btnNormal}"  
-                    VerticalOptions="End"  
-                    HorizontalOptions="End" 
-                    Margin="20,0,0,20"/>
-            </Grid>
-
-        </StackLayout>
-        <Grid Grid.RowSpan="1" IsVisible="{Binding IsBusy}">
-            <Border StrokeThickness="0"
-                Background="Black"
-                Opacity="0.5"
-                Padding="20"
-                WidthRequest="160"
-                HeightRequest="160"
-                HorizontalOptions="Center"
-                VerticalOptions="Center"
-                StrokeShape="RoundRectangle 20">
-
-                <VerticalStackLayout HorizontalOptions="Center" VerticalOptions="Center">
-                    <ActivityIndicator IsRunning="True" Color="White" />
-                    <Label Text="Chargement..."
-                        FontSize="14"
-                        TextColor="white"
-                        HorizontalOptions="Center"/>
-                </VerticalStackLayout>
-            </Border>
-        </Grid>
-
-    </Grid>
+<ContentPage xmlns="http://schemas.microsoft.com/dotnet/2021/maui"  
+            xmlns:x="http://schemas.microsoft.com/winfx/2009/xaml"  
+            xmlns:vm="clr-namespace:GES_PAC.ViewModel"  
+            xmlns:tools="clr-namespace:GES_PAC.View.Tools"  
+            x:Class="GES_PAC.View.SetListView"  
+            x:DataType="vm:SetListViewModel">  
+ 
+   <Grid>  
+       <StackLayout BackgroundColor="White" Spacing="50">  
+ 
+           <tools:ConnectionIndicatorView />  
+           <ScrollView>  
+               <StackLayout Spacing="100">  
+ 
+                   <Label Text="{Binding LastSetText}"  
+                       FontSize="18"  
+                       HorizontalOptions="Center"/>  
+ 
+               </StackLayout>  
+           </ScrollView>  
+           <StackLayout HorizontalOptions="Center" VerticalOptions="EndAndExpand" Spacing="75" Margin="0, 0, 0, 50">  
+ 
+               <Button  
+                   Text="Créer une série"  
+                   Command="{Binding GoToCreateSetCommand}"  
+                   Style="{StaticResource btnNormal}"  
+                   VerticalOptions="End"  
+                   HorizontalOptions="Center"/>  
+ 
+               <Button  
+                   Text="Reprendre la série"  
+                   Command="{Binding GoToLastSetCommand}"  
+                   Style="{StaticResource btnNormal}"  
+                   VerticalOptions="End"  
+                   HorizontalOptions="Center"  
+                   IsVisible="{Binding HasLastSet}"/>  
+ 
+               <Button  
+                   Text="Terminer la journée"  
+                   Command="{Binding GoToEndDayCommand}"  
+                   Style="{StaticResource btnNormal}"  
+                   VerticalOptions="End"  
+                   HorizontalOptions="Center"/>  
+           </StackLayout>  
+ 
+       </StackLayout>  
+       <Grid Grid.RowSpan="1" IsVisible="{Binding IsBusy}">  
+           <Border StrokeThickness="0"  
+               Background="Black"  
+               Opacity="0.5"  
+               Padding="20"  
+               WidthRequest="160"  
+               HeightRequest="160"  
+               HorizontalOptions="Center"  
+               VerticalOptions="Center"  
+               StrokeShape="RoundRectangle 20">  
+ 
+               <VerticalStackLayout HorizontalOptions="Center" VerticalOptions="Center">  
+                   <ActivityIndicator IsRunning="True" Color="White" />  
+                   <Label Text="Chargement..."  
+                       FontSize="14"  
+                       TextColor="white"  
+                       HorizontalOptions="Center"/>  
+               </VerticalStackLayout>  
+           </Border>  
+       </Grid>  
+ 
+   </Grid>  
 </ContentPage>
diff --git a/GES_PAC/ViewModel/Controls/ChamberButtonViewModel.cs b/GES_PAC/ViewModel/Controls/ChamberButtonViewModel.cs
index ec6084a..5d7aea4 100644
--- a/GES_PAC/ViewModel/Controls/ChamberButtonViewModel.cs
+++ b/GES_PAC/ViewModel/Controls/ChamberButtonViewModel.cs
@@ -8,7 +8,7 @@ namespace GES_PAC.ViewModel.Controls
     {
         #region Attributs
         private string _buttonText;
-        private int _buttonCommandParameter;
+        private int _chamberId;
         private Color _buttonBackgroundColor;
         private bool _buttonIsEnabled;
         private string _buttonLabel;
@@ -25,12 +25,12 @@ namespace GES_PAC.ViewModel.Controls
                 OnPropertyChanged();
             }
         }
-        public int ButtonCommandParameter
+        public int ChamberId
         {
-            get => _buttonCommandParameter;
+            get => _chamberId;
             set
             {
-                _buttonCommandParameter = value;
+                _chamberId = value;
                 OnPropertyChanged();
             }
         }
@@ -87,7 +87,7 @@ namespace GES_PAC.ViewModel.Controls
             CurrentSet = JourneeViewModel.Instance.GetCurrentSet();
 
             ButtonText = chamberId.ToString();
-            ButtonCommandParameter = chamberId;
+            ChamberId = chamberId;
 
             ButtonIsEnabled = JourneeViewModel.Instance.GetCurrentSet().GetIsInByNumeroBoite(chamberId);
             bool hasBehaviour = CurrentSet.GetHasBehaviourByNumeroBoite(chamberId);
@@ -103,10 +103,9 @@ namespace GES_PAC.ViewModel.Controls
             if (IsBusy) return;
             IsBusy = true;
 
-            if (CurrentSet.GetMeasureNumberByNumeroBoite(ButtonCommandParameter) == 0)
-                await Shell.Current.GoToAsync($"{nameof(EnterAnimalView)}?chamberId={ButtonCommandParameter}");
-            else
-                await Shell.Current.GoToAsync($"{nameof(CreateMeasureView)}?chamberId={ButtonCommandParameter}");
+            var targetView = (CurrentSet.GetMeasureNumberByNumeroBoite(ChamberId) == 0) ? nameof(EnterAnimalView) : nameof(CreateMeasureView);
+
+            await Shell.Current.GoToAsync($"{targetView}?chamberId={ChamberId}");
 
             IsBusy = false;
         }
diff --git a/GES_PAC/ViewModel/CreateCalibrationViewModel.cs b/GES_PAC/ViewModel/CreateCalibrationViewModel.cs
index 7b6be9a..6d01b21 100644
--- a/GES_PAC/ViewModel/CreateCalibrationViewModel.cs
+++ b/GES_PAC/ViewModel/CreateCalibrationViewModel.cs
@@ -1,8 +1,6 @@
-using CommunityToolkit.Maui.Core.Extensions;
 using GES_PAC.Model;
 using GES_PAC.View;
 using System.Collections.ObjectModel;
-using System.Diagnostics;
 using System.Windows.Input;
 
 namespace GES_PAC.ViewModel
@@ -17,6 +15,11 @@ namespace GES_PAC.ViewModel
         private double? _conc_ch4;
         private string _refBouteille;
         private bool _isRefBouteilleVisible;
+        private Calibration _lastCalibration;
+        private bool _hasLastMeasure;
+        private double? _lastO2;
+        private double? _lastCO2;
+        private double? _lastCH4;
         private bool _isFormValid;
         #endregion
 
@@ -34,6 +37,7 @@ namespace GES_PAC.ViewModel
                 _selectedType = value;
                 IsRefBouteilleVisible = _selectedType.Name != "Air";
                 OnPropertyChanged();
+                OnTypeChanged();
                 ValidateForm();
             }
         }
@@ -89,6 +93,51 @@ namespace GES_PAC.ViewModel
                 OnPropertyChanged();
             }
         }
+        public Calibration LastCalibration
+        {
+            get => _lastCalibration;
+            set
+            {
+                _lastCalibration = value;
+                OnPropertyChanged();
+            }
+        }
+        public bool HasLastMeasure
+        {
+            get => _hasLastMeasure;
+            set
+            {
+                _hasLastMeasure = value;
+                OnPropertyChanged();
+            }
+        }
+        public double? LastO2
+        {
+            get => _lastO2;
+            set
+            {
+                _lastO2 = value;
+                OnPropertyChanged();
+            }
+        }
+        public double? LastCO2
+        {
+            get => _lastCO2;
+            set
+            {
+                _lastCO2 = value;
+                OnPropertyChanged();
+            }
+        }
+        public double? LastCH4
+        {
+            get => _lastCH4;
+            set
+            {
+                _lastCH4 = value;
+                OnPropertyChanged();
+            }
+        }
 
         public bool IsFormValid
         {
@@ -110,15 +159,19 @@ namespace GES_PAC.ViewModel
         #region Constructeurs
         public CreateCalibrationViewModel()
         {
+            CreateCalibrationCommand = new Command(async () => await CreateCalibration());
 
             var journeeActuelle = JourneeViewModel.Instance.GetCurrentDay();
             var typesManquants = journeeActuelle.GetCurrentMissingCalibration();
 
             TypeCalibrations = new ObservableCollection<TypeCalibration>(typesManquants);
-
             SelectedType = TypeCalibrations[0];
 
-            CreateCalibrationCommand = new Command(async () => await CreateCalibration());
+            if (journeeActuelle.GetCurrentPhase() == PhaseCalibration.Fin)
+            { 
+                LastCalibration = journeeActuelle.GetDebutCalibration();
+                HasLastMeasure = true;
+            }
         }
         #endregion
 
@@ -133,14 +186,11 @@ namespace GES_PAC.ViewModel
             var phaseCalibration = JourneeViewModel.Instance.GetCurrentPhase();
             var isComplete = JourneeViewModel.Instance.GetCurrentDay().AddCalibration(newCalib, phaseCalibration);
 
-            if (isComplete)
-            {
-                await Shell.Current.GoToAsync(nameof(SetListView));
-            }
-            else
-            {
-                await Shell.Current.GoToAsync(nameof(CreateCalibrationView));
+            var targetView = nameof(CreateCalibrationView);
+            if (isComplete) {
+                targetView = phaseCalibration == PhaseCalibration.Debut ? nameof(SetListView) : nameof(MainView);
             }
+            await Shell.Current.GoToAsync(targetView);
 
             IsBusy = false;
         }
@@ -163,6 +213,16 @@ namespace GES_PAC.ViewModel
 
             (CreateCalibrationCommand as Command)?.ChangeCanExecute();
         }
+
+        private void OnTypeChanged()
+        {
+            if (!HasLastMeasure)
+                return;
+            var mesureCalibration = LastCalibration.getMesureCalibrationByType(SelectedType);
+            LastCH4 = mesureCalibration.Conc_CH4;
+            LastO2 = mesureCalibration.Conc_O2;
+            LastCO2 = mesureCalibration.Conc_CO2;
+        }
         #endregion
     }
 }
diff --git a/GES_PAC/ViewModel/EndDayViewModel.cs b/GES_PAC/ViewModel/EndDayViewModel.cs
new file mode 100644
index 0000000..bdc9f8e
--- /dev/null
+++ b/GES_PAC/ViewModel/EndDayViewModel.cs
@@ -0,0 +1,79 @@
+﻿using GES_PAC.View;
+
+namespace GES_PAC.ViewModel
+{
+    public class EndDayViewModel : BaseViewModel
+    {
+        #region Attributs
+        private int _numberSet;
+        private int _numberAnimal;
+        private int _numberMeasure;
+        private int _numberBehaviour;
+        #endregion
+
+        #region Commandes
+        public Command GoToCalibrationCommand { get; }
+        #endregion
+
+        #region Propriétés
+        public int NumberSet
+        {
+            get => _numberSet;
+            set
+            {
+                SetProperty(ref _numberSet, value);
+                OnPropertyChanged();
+            }
+        }
+        public int NumberAnimal
+        {
+            get => _numberAnimal;
+            set
+            {
+                SetProperty(ref _numberAnimal, value);
+                OnPropertyChanged();
+            }
+        }
+        public int NumberMeasure
+        {
+            get => _numberMeasure;
+            set
+            {
+                SetProperty(ref _numberMeasure, value);
+                OnPropertyChanged();
+            }
+        }
+        public int NumberBehaviour
+        {
+            get => _numberBehaviour;
+            set
+            {
+                SetProperty(ref _numberBehaviour, value);
+                OnPropertyChanged();
+            }
+        }
+        #endregion
+
+        #region Constructeur
+        public EndDayViewModel()
+        {
+            var journeeActuelle = JourneeViewModel.Instance.GetCurrentDay();
+            NumberSet = journeeActuelle.GetSetCount();
+            NumberAnimal = journeeActuelle.GetDayAnimalCount();
+            NumberMeasure = journeeActuelle.GetDayMeasureCount();
+            NumberBehaviour = journeeActuelle.GetDayBehaviourCount();
+            GoToCalibrationCommand = new Command(async () => await GoToCalibrationPage());
+        }
+        #endregion
+
+        #region Méthodes
+        private async Task GoToCalibrationPage()
+        {
+            if (IsBusy) return;
+            IsBusy = true;
+            await Shell.Current.GoToAsync(nameof(CreateCalibrationView));
+            IsBusy = false;
+        }
+        #endregion
+    }
+}
diff --git a/GES_PAC/ViewModel/EndSetViewModel.cs b/GES_PAC/ViewModel/EndSetViewModel.cs
index 2281dee..c4605ac 100644
--- a/GES_PAC/ViewModel/EndSetViewModel.cs
+++ b/GES_PAC/ViewModel/EndSetViewModel.cs
@@ -1,6 +1,4 @@
-﻿using GES_PAC.Model;
-using GES_PAC.Services;
-using GES_PAC.View;
+﻿using GES_PAC.View;
 
 namespace GES_PAC.ViewModel
 {
@@ -13,7 +11,7 @@ namespace GES_PAC.ViewModel
         #endregion
 
         #region Commandes
-        public Command GoToCreateDayCommand { get; }
+        public Command GoToSetListCommand { get; }
         #endregion
 
         #region Propriétés
@@ -52,12 +50,12 @@ namespace GES_PAC.ViewModel
             NumberAnimal = serieActuelle.GetAnimalCount();
             NumberMeasure = serieActuelle.GetMeasureCount();
             NumberBehaviour = serieActuelle.GetBehaviourCount();
-            GoToCreateDayCommand = new Command(async () => await GoToCreateDayPage());
+            GoToSetListCommand = new Command(async () => await GoToSetListPage());
         }
         #endregion
 
         #region Méthodes
-        private async Task GoToCreateDayPage()
+        private async Task GoToSetListPage()
         {
             if (IsBusy) return;
             IsBusy = true;
diff --git a/GES_PAC/ViewModel/MainViewModel.cs b/GES_PAC/ViewModel/MainViewModel.cs
index 1644673..d4b0ad8 100644
--- a/GES_PAC/ViewModel/MainViewModel.cs
+++ b/GES_PAC/ViewModel/MainViewModel.cs
@@ -18,12 +18,15 @@ namespace GES_PAC.ViewModel
         public MainViewModel(ConnexionService connService)
         {
             //ONLY FOR TESTS
-            //var date = DateTime.Now;
-            //var newDay = new Journee(date, PersonViewModel.Instance.Persons[0], PlaceViewModel.Instance.Places[0], "");
-            //newDay.AddSet(new Serie(date, date, 25, 25, 25));
-            //newDay.GetCurrentSet().AddSerieAnimal(new SerieAnimal(1, 500, date, ""));
-            //newDay.GetCurrentSet().AddMeasure(new Mesure(date, 50, 50, 50), 1, false);
-            //JourneeViewModel.Instance.Journees.Add(newDay);
+            var date = DateTime.Now;
+            var newDay = new Journee(date, PersonViewModel.Instance.Persons[0], PlaceViewModel.Instance.Places[0], "");
+            newDay.AddSet(new Serie(date, date, 25, 25, 25));
+            newDay.AddCalibration(new MesureCalibration(date, 50, 40, 500, TypeCalibration.Air, ""), PhaseCalibration.Debut);
+            newDay.AddCalibration(new MesureCalibration(date, 0, 0, 1000000, TypeCalibration.Methane, "dazdazd"), PhaseCalibration.Debut);
+            newDay.AddCalibration(new MesureCalibration(date, 30, 30, 3000, TypeCalibration.Melange, "deqsfsdf"), PhaseCalibration.Debut);
+            newDay.GetCurrentSet().AddSerieAnimal(new SerieAnimal(1, 500, date, ""));
+            newDay.GetCurrentSet().AddMeasure(new Mesure(date, 50, 50, 50), 1, false);
+            JourneeViewModel.Instance.Journees.Add(newDay);
             //ONLY FOR TESTS
 
             this.connService = connService;
diff --git a/GES_PAC/ViewModel/SetListViewModel.cs b/GES_PAC/ViewModel/SetListViewModel.cs
index dbc9d8d..62cb99a 100644
--- a/GES_PAC/ViewModel/SetListViewModel.cs
+++ b/GES_PAC/ViewModel/SetListViewModel.cs
@@ -27,6 +27,7 @@ namespace GES_PAC.ViewModel
         #region Commandes
         public ICommand GoToCreateSetCommand { get; }
         public ICommand GoToLastSetCommand { get; }
+        public ICommand GoToEndDayCommand { get; }
         #endregion
 
         #region Constructeur
@@ -34,6 +35,7 @@ namespace GES_PAC.ViewModel
         {
             GoToCreateSetCommand = new Command(async () => await GoToCreateSetPage());
             GoToLastSetCommand = new Command(async () => await GoToLastSetPage());
+            GoToEndDayCommand = new Command(async () => await GoToEndDayPage());
 
             HasLastSet = JourneeViewModel.Instance.GetCurrentDay().HasAnySet();
         }
@@ -55,6 +57,13 @@ namespace GES_PAC.ViewModel
             await Shell.Current.GoToAsync(nameof(ChambersView));
             IsBusy = false;
         }
+        private async Task GoToEndDayPage()
+        {
+            if (IsBusy) return;
+            IsBusy = true;
+            await Shell.Current.GoToAsync(nameof(EndDayView));
+            IsBusy = false;
+        }
         #endregion
     }
 }